poj3744之矩阵快速幂+概率DP

Scout YYF I

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 4410   Accepted: 1151

Description

YYF is a couragous scout. Now he is on a dangerous mission which is to penetrate into the enemy‘s base. After overcoming a series difficulties, YYF is now at the start of enemy‘s famous "mine road". This is a very long road, on which there are numbers of mines.
At first, YYF is at step one. For each step after that, YYF will walk one step with a probability of p, or jump two step with a probality of 1-p. Here is the task, given the place of each mine, please calculate the probality that YYF can
go through the "mine road" safely.

Input

The input contains many test cases ended with EOF.

Each test case contains two lines.

The First line of each test case is N (1 ≤ N ≤ 10) and p (0.25 ≤ p ≤ 0.75) seperated by a single blank, standing for the number of mines and the probability to walk one step.

The Second line of each test case is N integer standing for the place of N mines. Each integer is in the range of [1, 100000000].

Output

For each test case, output the probabilty in a single line with the precision to 7 digits after the decimal point.

Sample Input

1 0.5
2
2 0.5
2 4

Sample Output

0.5000000
0.2500000
/*分析:对于n个地雷s[1],s[2],s[3],s[4]...s[n]
假设s都是不递减的。
假设dp[i]表示从1到达i这个位置的概率
则:
dp[s[1]-1]为1~s[1]-1的概率//s[1]不能到达
dp[s[2]-1]为1~s[2]-1也是1->s[1]-1->s[1]+1->s[2]-1的概率
由于最多只能跳两格
所以dp[s[i]+1]一定是从dp[s[i]-1]到达
然后从dp[s[i]+1]到达dp[s[i+1]-1];//这部分就可以用矩阵快速幂
另外根据公式dp[i]=p*dp[i-1]+(1-p)*dp[i-2]也可知从s[i]+1 => s[i+1]-1用矩阵快速幂求
构造初始矩阵:
p 1-p   *  dp[i]      =  dp[i+1]
1 0        dp[i-1]        dp[i]
*/
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <queue>
#include <algorithm>
#include <map>
#include <cmath>
#include <iomanip>
#define INF 99999999
typedef long long LL;
using namespace std;

const int MAX=10+10;
const int N=2;
int n,s[MAX];
double array[N][N],sum[N][N],p;

void InitMatrix(){
	array[0][0]=p;
	array[0][1]=1-p;
	array[1][0]=1;
	array[1][1]=0;
	for(int i=0;i<N;++i){
		for(int j=0;j<N;++j)sum[i][j]=(i == j);
	}
}

void MatrixMult(double a[N][N],double b[N][N]){
	double c[N][N]={0};
	for(int i=0;i<N;++i){
		for(int j=0;j<N;++j){
			for(int k=0;k<N;++k){
				c[i][j]+=a[i][k]*b[k][j];
			}
		}
	}
	for(int i=0;i<N;++i)for(int j=0;j<N;++j)a[i][j]=c[i][j];
}

double Matrix(int k){
	if(k<0)return 0;//表示s[i-1]~s[i]之间无位置
	InitMatrix();//初始化矩阵
	while(k){//有k+1个位置,到达第k+1个位置所以是k次
		if(k&1)MatrixMult(sum,array);
		MatrixMult(array,array);
		k>>=1;
	}
	return sum[0][0];//sum[0][0]*dp[1]+sum[0][1]*dp[0]
}

int main(){
	while(~scanf("%d%lf",&n,&p)){
		for(int i=1;i<=n;++i)scanf("%d",&s[i]);
		sort(s+1,s+1+n);
		double ans=Matrix(s[1]-2);//1~s[1]-1的概率
		for(int i=2;i<=n;++i){
			if(s[i] == s[i-1])continue;
			double temp=Matrix(s[i]-s[i-1]-2);//s[i-1]~s[i]之间有s[i]-s[i-1]-1个位置,需要走s[i]-s[i-1]-2次到达最后一个位置
			ans=ans*(1-p)*temp;//从s[i-1]-1的位置跳两格到s[i-1]+1再到s[i]-1
		}
		printf("%.7f\n",ans*(1-p));//在s[n]-1位置还需要跳两格才安全了
	}
	return 0;
}

poj3744之矩阵快速幂+概率DP,布布扣,bubuko.com

时间: 2024-12-26 12:38:50

poj3744之矩阵快速幂+概率DP的相关文章

POJ 3744 Scout YYF I(矩阵快速幂 概率dp)

题目链接:http://poj.org/problem?id=3744 Description YYF is a couragous scout. Now he is on a dangerous mission which is to penetrate into the enemy's base. After overcoming a series difficulties, YYF is now at the start of enemy's famous "mine road"

ASC(1)E(矩阵快速幂+简单DP)

Nice Patterns Strike Back Time Limit: 20000/10000MS (Java/Others)Memory Limit: 128000/64000KB (Java/Others) SubmitStatisticNext Problem Problem Description You might have noticed that there is the new fashion among rich people to have their yards til

矩阵快速幂 优化dp 模板

相关博客 :https://blog.csdn.net/china_xyc/article/details/89819376#commentBox 关于能用矩阵乘法优化的DP题目,有如下几个要求: 转移式只有加法,清零,减法etc.,max和min运算不允许 转移式中关于前几位dp结果得到的系数必须是常量 转移次数一般超级多 由于转移次数多,一般都要模一个int范围内的数 综上,举一个例子: dp[i]=a×dp[i−1]+b×dp[i−2]+c×dp[i−3] 其中,a,b,c是常量,而在需要

hihoCoder #1151 : 骨牌覆盖问题&#183;二 (矩阵快速幂,DP)

题意:给一个3*n的矩阵,要求用1*2的骨牌来填满,有多少种方案? 思路: 官网题解用的仍然是矩阵快速幂的方式.复杂度O(logn*83). 这样做需要构造一个23*23的矩阵,这个矩阵自乘n-1次,再来乘以初始矩阵init{0,0,0,0,0,0,0,1}后,变成矩阵ans{x,x,x,x,x,x,x,y},y就是答案了,而x不必管. 主要在这个矩阵的构造,假设棋盘是放竖直的(即n*3),那么考虑在第i行进行填放,需要考虑到第i-1行的所有可能的状态(注意i-2行必须是已经填满了,否则第i行无

POJ3734Blocks矩阵快速幂加dp思想

#include <cstdio> #include <algorithm> #include <iostream> #include <vector> using namespace std; typedef vector<int> vec; typedef vector<vec> mat; const int M=10007; typedef long long LL; mat mul(mat &A,mat &B)

排队 矩阵快速幂优化dp

\(T1\) 排队 ? Description ?? 抢饭是高中生活的一部分,现在有一列队伍长度为 \(n\),(注意:由于人与人之间要保持距离,且不同情况所保持的距离大小不同,所以长度并不能直接体现队列的人数).已知男男之间的距离为 \(a\),男女之间距离为 bb,女女之间距离为 \(c\).一个男生打饭时间为 \(d\),一个女生打饭时间为 \(e\),求所有情况的排队时间总和(忽略身体的大小对队伍长度的贡献),答案对 $10^{9}+7 $取模. ?? Input Format 一行六个

bzoj 4000 矩阵快速幂优化DP

建立矩阵,跑快速幂 1 /************************************************************** 2 Problem: 4000 3 User: idy002 4 Language: C++ 5 Result: Accepted 6 Time:32 ms 7 Memory:836 kb 8 ****************************************************************/ 9 10 #inclu

LibreOJ #2325. 「清华集训 2017」小Y和恐怖的奴隶主(矩阵快速幂优化DP)

哇这题剧毒,卡了好久常数才过T_T 设$f(i,s)$为到第$i$轮攻击,怪物状态为$s$时对boss的期望伤害,$sum$为状态$s$所表示的怪物个数,得到朴素的DP方程$f(i,s)=\sum \frac{1}{sum+1}*(f(i+1,s')+[s==s'])$ 状态数只有$C_{8+3}^3=165$个,所以就可以矩乘优化啦.再加上一个用于转移的$1$,矩阵大小是$166*166$的,因为多组询问,所以可以先把$2$的所有次幂的矩阵都预处理出来. 然后会发现复杂度是$O(T*166^3

hihoCoder #1162 : 骨牌覆盖问题&#183;三 (矩阵快速幂,DP)

题意:有一个k*n的棋盘,要求用1*2的骨牌来铺满,有多少种方案?(k<8,n<100000001) 思路: 由于k是比较小,但是又不那么小,可以专门构造这样的一个矩阵M,使得只要我们有一个初始矩阵R,求得ans矩阵,然后答案就在ans中了.ans=R*Mn. M的大小应该是2k*2k,所以当k稍微大一些就不合适存储这个矩阵了,而且里面大部分都是0,很浪费.由于k<8,所以M的大小为128*128是可以接受的.复杂度是O(23*k*logn),大概是千万级别的. 1 #include &